unit frmInIOCPWebSocketJSON;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, fmIOCPSvrInfo, iocp_managers, iocp_base,
  http_objects, iocp_server, iocp_sockets, iocp_wsClients;

type
  TFormInIOCPWsJSON = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Memo1: TMemo;
    InIOCPServer1: TInIOCPServer;
    InHttpDataProvider1: TInHttpDataProvider;
    InWebSocketManager1: TInWebSocketManager;
    FrameIOCPSvrInfo1: TFrameIOCPSvrInfo;
    InWSConnection1: TInWSConnection;
    btnConnect: TButton;
    btnSend: TButton;
    Button3: TButton;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure InIOCPServer1AfterOpen(Sender: TObject);
    procedure InHttpDataProvider1Accept(Sender: TObject; Request: THttpRequest;
      var Accept: Boolean);
    procedure InWebSocketManager1Upgrade(Sender: TObject; const Origin: string;
      var Accept: Boolean);
    procedure InWebSocketManager1Receive(Sender: TObject; Socket: TWebSocket);
    procedure btnConnectClick(Sender: TObject);
    procedure InWSConnection1AfterConnect(Sender: TObject);
    procedure btnSendClick(Sender: TObject);
    procedure InWSConnection1ReceiveData(Sender: TObject; const Msg: string);
    procedure InWSConnection1ReceiveMsg(Sender: TObject; MsgType: TWSMsgType;
      Msg: TJSONResult);
    procedure InWSConnection1ReturnResult(Sender: TObject; MsgType: TWSMsgType;
      Result: TJSONResult);
    procedure Button3Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FormInIOCPWsJSON: TFormInIOCPWsJSON;

implementation

uses
  iocp_varis, iocp_utils, iocp_log;

{$R *.dfm}

procedure TFormInIOCPWsJSON.btnConnectClick(Sender: TObject);
begin
  InWSConnection1.Active := not InWSConnection1.Active;
end;

procedure TFormInIOCPWsJSON.btnSendClick(Sender: TObject);
var
  JSON: TJSONMessage;
begin

  //  1ʹ InWSConnection1  JSON
{  with InWSConnection1.JSON do
  begin
    S['aaa'] := 'WebSocket test + .';
    S['BBB'] := 'ba +';
    Post;
  end;     }

  //  2
  JSON := TJSONMessage.Create(InWSConnection1);
  JSON.S['aaa'] := ' InIOCP  WebSocket ͻˣ.';
  JSON.S['BBB'] := 'bbb ';

  JSON.Attachment := TFileStream.Create('doc\WebSocketExe.7z', fmOpenRead);
  JSON.S['attach'] := 'WebSocketExe.7z';  // ˱

  JSON.Post;

end;

procedure TFormInIOCPWsJSON.Button1Click(Sender: TObject);
begin
  // °ݱ׼ WebSocket ϢϢ JSON װִ֧ļ
  iocp_log.TLogThread.InitLog(iocp_varis.gAppPath + 'log');  // ־
  FrameIOCPSvrInfo1.Start(InIOCPServer1);
  InIOCPServer1.Active := True;
end;

procedure TFormInIOCPWsJSON.Button2Click(Sender: TObject);
begin
  FrameIOCPSvrInfo1.Stop;
  InIOCPServer1.Active := False;
  iocp_log.TLogThread.StopLog;  // ֹͣ־  
end;

procedure TFormInIOCPWsJSON.Button3Click(Sender: TObject);
begin
  InIOCPServer1AfterOpen(nil);
end;

procedure TFormInIOCPWsJSON.FormCreate(Sender: TObject);
begin
  iocp_varis.gAppPath := ExtractFilePath(Application.ExeName);  // ·
  iocp_utils.MyCreateDir(iocp_varis.gAppPath + 'log');  // ־Ŀ¼
end;

procedure TFormInIOCPWsJSON.InHttpDataProvider1Accept(Sender: TObject;
  Request: THttpRequest; var Accept: Boolean);
begin
  // Accept Ĭ = True
end;

procedure TFormInIOCPWsJSON.InIOCPServer1AfterOpen(Sender: TObject);
begin
  Memo1.Lines.Clear;
  Memo1.Lines.Add('IP:' + InIOCPServer1.ServerAddr);
  Memo1.Lines.Add('Port:' + IntToStr(InIOCPServer1.ServerPort));  
end;

procedure TFormInIOCPWsJSON.InWebSocketManager1Receive(Sender: TObject; Socket: TWebSocket);
var
  S: AnsiString;
begin
  // WebSocket յϢ¼
  // WebSocket ֡䣬ϵͳֵֻ֧֡
  // Ĭϵ WebSocket Ϣδװ JSON װ

  // Socket յݷ֣ MsgType ֵ
  //  1.    mtDefault:  InIOCP-JSON װı׼ WebSocket ݣ
  //  2.       mtJSON:  InIOCP-JSON װչ JSON Ϣ
  //  3. mtAttachment:  InIOCP-JSON װĸ

  // MsgType Ϊ mtDefault ʱ Socket ԣ
  // 1         Dataյλ
  // 2FrameRecvSizeյݳ
  // 3    FrameSizeǰ֡ܳ
  // 4      MsgSizeǰϢۼյݳȣܺ֡ݣ
  // 5     CompleteǰϢǷϣTrue ʱ MsgSize ΪϢʵʳ
  // 6       OpCodeرʱҲ¼

  // InIOCP-JSON װϢ֧ 1-4 ԣҪԣ
  //        7  JSON: յ JSON Ϣ
  //        8Result: Ҫ JSON Ϣ SendResult ͡

  Memo1.Lines.Add('======  ======');
  
  case Socket.MsgType of  // 3͵
    mtJSON: begin
      // 1. InIOCP չ JSON Ϣʱ Socket.Complete = True
      Memo1.Lines.Add('aaa=' + Socket.JSON.S['aaa']);
      Memo1.Lines.Add('bbb=' + Socket.JSON.S['BBB']);
      Memo1.Lines.Add('=' + Socket.JSON.S['attach']);

      Memo1.Lines.Add('JSON ı:');
      Memo1.Lines.Add(Socket.JSON.Text);

      if Socket.JSON.HasAttachment then //  -> ļոʱ
        Socket.JSON.Attachment := TFileStream.Create('temp\յ' + Socket.JSON.S['attach'], fmCreate);

      Socket.UserName := 'JSON';
//     InWebSocketManager1.SendTo(Socket, 'ToUser');

//      Socket.Result.S['return'] := 'test Ϣ';
//      Socket.SendResult;  // ͽͻ
    end;

    mtAttachment: begin
      // 2. InIOCP չ  ݣʱ Socket.Complete = True
      //     Socket.JSON.Attachment δգִе

      // ϵͳԶرո Socket.JSON.Attachment
      Memo1.Lines.Add('ϣϵͳԶرո');

      // Ϣ + 
      Socket.Result.S['return'] := 'test Ϣ+';

      Socket.Result.Attachment := TFileStream.Create('doc\Form.7z', fmOpenRead);  // 
      Socket.Result.S['attach'] := 'Form.7z';  // 

      Socket.SendResult;  // 
      
    end;
    else begin

      // 3. ׼ WebSocket ݣģSocket.Complete δΪ True
      
      if Socket.Complete then // Ϣ
      begin
        // ˫ֽڵ UTF8To ϵкĴ AnsiString Ϊ
        //  S Ϊ AnsiString 
        SetString(S, Socket.Data, Socket.FrameRecvSize); // ϢתΪ String

        Socket.UserName := System.Utf8ToAnsi(S); // XE10  UTF8ToString(S)
        Memo1.Lines.Add(Socket.UserName);
        
        // ȫͻб
//        InWebSocketManager1.GetUserList(Socket);

        InWebSocketManager1.Broadcast(Socket);

        // ȫͻˣUserName 
//        InWebSocketManager1.Broadcast('ҹ㲥' + Socket.UserName + '.');

{       // ·

        // 1. Ϣͻ
        Socket.SendData('' + Socket.UserName);

        // 2. ѾǼûȫû
        //    бͻˣJSONʽֶΪ NAMEĬַ
        InWebSocketManager1.GetUserList(Socket);

        // 3. 㲥 Socket յϢ
        InWebSocketManager1.Broadcast(Socket);

        // 4. յϢ ToUser
        InWebSocketManager1.SendTo(Socket, 'ToUser');

        // 5. 㲥һıϢ
        InWebSocketManager1.Broadcast('Թ㲥');

        // 6. һı ToUser
        InWebSocketManager1.SendTo('ToUser', '͸ToUser');

        // 7. ɾͻ AAA
        if (Socket.Role >= crAdmin) then  // Ȩ
          InWebSocketManager1.Delete(Socket, 'ûA'); }

    //    Memo1.Lines.Add('յ WebSocket Ϣ' + S);  // 󲢷Ҫʾ
      end;
    end;
  end;
end;

procedure TFormInIOCPWsJSON.InWebSocketManager1Upgrade(Sender: TObject;
  const Origin: string; var Accept: Boolean);
begin
  // Origin:  Socket Դ磺www.aaa.com
  // ڴжǷΪ WebSocketĬ Accept=True
end;

procedure TFormInIOCPWsJSON.InWSConnection1AfterConnect(Sender: TObject);
begin
  if InWSConnection1.Active then
  begin
    btnConnect.Caption := 'Ͽ';
    btnSend.Enabled := True;
  end else
  begin
    btnConnect.Caption := '';
    btnSend.Enabled := False;    
  end;
end;

procedure TFormInIOCPWsJSON.InWSConnection1ReceiveData(Sender: TObject; const Msg: string);
begin
  // Sender:  TInWSConnection
  //    MsgյϢı

  // յĲ InIOCP-JSON Ϣδװݣ
  // ԷһϢڷ˹㲥

  Memo1.Lines.Add(Msg);

end;

procedure TFormInIOCPWsJSON.InWSConnection1ReceiveMsg(Sender: TObject; MsgType: TWSMsgType; Msg: TJSONResult);
begin
  //  Sender:  TInWSConnection
  // MsgType: Ϊ mtJSON
  //     Msg: JSON ϢϵͳԶͷ

  // յͻ InIOCP-JSON Ϣգ
  // Է TJSONMessage Ϣڷ˹㲥

  Memo1.Lines.Add('յϢգ' + Msg.S['push']);
end;

procedure TFormInIOCPWsJSON.InWSConnection1ReturnResult(Sender: TObject; MsgType: TWSMsgType; Result: TJSONResult);
begin
  //  Sender:  TInWSConnection
  // MsgType: Ϣ
  //          1. mtJSONResult  JSON Ϣ
  //          2. mtAttachmentResult ǸϵͳԶͷţҪ Result.Attachment.Free
  //  Result: JSON ϢϵͳԶͷ

  // Ƿ InIOCP-JSON Ϣ󣬷˷ InIOCP-JSON Ϣ
  // ԷյϢ Socket.Result Socket.SendResult ͻ

  Memo1.Lines.Add('====== ͻ ======');

  if MsgType = mtJSON then
  begin
    if Result.HasAttachment then  // иգԲգ
      Result.Attachment := TFileStream.Create('temp\ͻյ' + Result.S['attach'], fmCreate);
    Memo1.Lines.Add('˷ظԼ JSON Ϣ: ' + Result.S['return']);
  end else  // Ǹ
  if Assigned(Result.Attachment) then  // յļ
    Memo1.Lines.Add('ļϣϵͳԶرո')
  else
    Memo1.Lines.Add('ûнļ');
end;

end.
