unit frmInIOCPWebSocketJSON;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, fmIOCPSvrInfo, iocp_managers, iocp_base,
  http_objects, iocp_server, iocp_sockets, iocp_wsClients;

type
  TFormInIOCPWsJSON = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Memo1: TMemo;
    InIOCPServer1: TInIOCPServer;
    InHttpDataProvider1: TInHttpDataProvider;
    InWebSocketManager1: TInWebSocketManager;
    FrameIOCPSvrInfo1: TFrameIOCPSvrInfo;
    Button3: TButton;
    InDatabaseManager1: TInDatabaseManager;
    InFileManager1: TInFileManager;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure InIOCPServer1AfterOpen(Sender: TObject);
    procedure InHttpDataProvider1Accept(Sender: TObject; Request: THttpRequest;
      var Accept: Boolean);
    procedure InWebSocketManager1Upgrade(Sender: TObject; const Origin: string;
      var Accept: Boolean);
    procedure InWebSocketManager1Receive(Sender: TObject; Socket: TWebSocket);
    procedure InWSConnection1ReceiveData(Sender: TObject; const Msg: string);
    procedure InWSConnection1ReceiveMsg(Sender: TObject; Msg: TJSONResult);
    procedure InWSConnection1ReturnResult(Sender: TObject; Result: TJSONResult);
    procedure Button3Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FormInIOCPWsJSON: TFormInIOCPWsJSON;

implementation

uses
  iocp_varis, iocp_utils, iocp_log, dm_iniocp_test;

{$R *.dfm}

procedure TFormInIOCPWsJSON.Button1Click(Sender: TObject);
begin
  // °ݱ׼ WebSocket ϢϢ JSON װִ֧ļ

  //  TInIOCPDataModule ̳µģ TdmInIOCPTest
  //    עģͼɣϵͳԶģʵ
  //    ֹͣʱģб
  InDatabaseManager1.AddDataModule(TdmInIOCPTest, 'ADO_xzqh');

  iocp_log.TLogThread.InitLog(iocp_varis.gAppPath + 'log');  // ־
  FrameIOCPSvrInfo1.Start(InIOCPServer1);
  InIOCPServer1.Active := True;
end;

procedure TFormInIOCPWsJSON.Button2Click(Sender: TObject);
begin
  FrameIOCPSvrInfo1.Stop;
  InIOCPServer1.Active := False;
  iocp_log.TLogThread.StopLog;  // ֹͣ־  
end;

procedure TFormInIOCPWsJSON.Button3Click(Sender: TObject);
begin
  InIOCPServer1AfterOpen(nil);
end;

procedure TFormInIOCPWsJSON.FormCreate(Sender: TObject);
begin
  iocp_varis.gAppPath := ExtractFilePath(Application.ExeName);  // ·
  iocp_utils.MyCreateDir(iocp_varis.gAppPath + 'log');  // ־Ŀ¼
end;

procedure TFormInIOCPWsJSON.InHttpDataProvider1Accept(Sender: TObject;
  Request: THttpRequest; var Accept: Boolean);
begin
  // Accept Ĭ = True
end;

procedure TFormInIOCPWsJSON.InIOCPServer1AfterOpen(Sender: TObject);
begin
  Memo1.Lines.Clear;
  Memo1.Lines.Add('IP:' + InIOCPServer1.ServerAddr);
  Memo1.Lines.Add('Port:' + IntToStr(InIOCPServer1.ServerPort));
end;

procedure TFormInIOCPWsJSON.InWebSocketManager1Receive(Sender: TObject; Socket: TWebSocket);
var
  S: AnsiString;
begin
  // WebSocket յϢ¼
  // WebSocket ֡䣬Ĭϵ WebSocket Ϣδװ JSON װ

  // Socket յݷ֣ MsgType ֵ
  //  1.    mtDefault:  InIOCP-JSON װı׼ WebSocket ݣ
  //  2.       mtJSON:  InIOCP-JSON װչ JSON Ϣ
  //  3. mtAttachment:  InIOCP-JSON װĸ

  // MsgType Ϊ mtDefault ʱ Socket ԣ
  // 1         Dataյλ
  // 2FrameRecvSizeյݳ
  // 3    FrameSizeǰ֡ܳ
  // 4      MsgSizeǰϢۼյݳȣܺ֡ݣ
  // 5     CompleteǰϢǷϣTrue ʱ MsgSize ΪϢʵʳ
  // 6       OpCodeرʱҲ¼

  // InIOCP-JSON װϢ֧ 1-4 ԣҪԣ
  //        7  JSON: յ JSON Ϣ
  //        8Result: Ҫ JSON Ϣ SendResult ͡

  //  SendResult ݸͻˣ

  case Socket.MsgType of  // 3͵
    mtJSON: // 1. InIOCP չ JSON Ϣʱ Socket.Complete = True
      case Socket.JSON.Action of
        33:  // 㲥
          InWebSocketManager1.Broadcast(Socket);

        11: begin  // ִݿѯ
          Memo1.Lines.Add('aaa=' + Socket.JSON.S['aaa']);
          // ѯ
//          Socket.Result.Action := 11;  // °Զ Action
          TBusiWorker(Sender).DataModule.WebSocketQuery(Socket.JSON, Socket.Result);
          Socket.SendResult;  // Ĭַ UTF-8
        end;

        12: begin // ݱ
//          Socket.Result.Action := 12;   // °Զ Action

          TBusiWorker(Sender).DataModule.WebSocketUpdates(Socket.JSON, Socket.Result);

          Socket.SendResult;
        end;

        20: begin // ѯļ
//          Socket.Result.Action := 20;  // °Զ Action

          // ѯ·gAppPath + 'form\'
          InFileManager1.ListFiles(Socket.Result, gAppPath + Socket.JSON.S['path']);

          Socket.SendResult;

          // ԰ļһ:
        { for i := 0 to Count - 1 do
          begin
            Socket.Result.Attachment := TFileStream.Create('??' + , fmShareDenyWrite);
            Socket.Result.S['fileName'] := '??';
            Socket.SendResult;
          end;  }

        end;

        else begin
          // Ϣ
          Memo1.Lines.Add('aaa=' + Socket.JSON.S['aaa']);
          Memo1.Lines.Add('bbb=' + Socket.JSON.S['BBB']);
          Memo1.Lines.Add('=' + Socket.JSON.S['attach']);

          if Socket.JSON.HasAttachment then //  -> ļոʱ
            Socket.JSON.Attachment := TFileStream.Create('temp\յ' + Socket.JSON.S['attach'], fmCreate);

          Socket.UserName := 'JSON';
    //     InWebSocketManager1.SendTo(Socket, 'ToUser');

    //      Socket.Result.S['return'] := 'test Ϣ';
    //      Socket.SendResult;  // ͽͻ
        end;

      end;

    mtAttachment: begin
      // 2. InIOCP չ  ݣʱ Socket.Complete = True
      //     Socket.JSON.Attachment δգִе

      // ϵͳԶرո Socket.JSON.Attachment
      Memo1.Lines.Add('ϣϵͳԶرո');

      // Ϣ
      Socket.Result.S['return'] := 'test Ϣ+';

      // A. ظ
      Socket.Result.Attachment := TFileStream.Create('Doc\Form.7z', fmShareDenyWrite);
      Socket.Result.S['attach'] := 'Form.7z';
      Socket.SendResult;  // Ĭַ UTF-8

      // 
      // B. ѯݿ⣬ Data ݣҲǸ
      //     Data ĸ߻⡣

 {     TBusiWorker(Sender).DataModule.WebSocketQuery(Socket.JSON, Socket.Result);
      Socket.SendResult;  // Ĭַ UTF-8  }

    end;

    else begin

      // 3. ׼ WebSocket ݣģSocket.Complete δΪ True
      
      if Socket.Complete then // Ϣ
      begin
        // ˫ֽڵ UTF8To ϵкĴ AnsiString Ϊ
        //  S Ϊ AnsiString 
        SetString(S, Socket.Data, Socket.FrameRecvSize); // ϢתΪ String

        Socket.UserName := System.Utf8ToAnsi(S); // XE10  UTF8ToString(S)
        Memo1.Lines.Add(Socket.UserName);
        
        // ȫͻб
//        InWebSocketManager1.GetUserList(Socket);

        InWebSocketManager1.Broadcast(Socket);

        // ȫͻˣUserName 
//        InWebSocketManager1.Broadcast('ҹ㲥' + Socket.UserName + '.');

{       // ·

        // 1. Ϣͻ
        Socket.SendData('' + Socket.UserName);

        // 2. ѾǼûȫû
        //    бͻˣJSONʽֶΪ NAMEĬַ
        InWebSocketManager1.GetUserList(Socket);

        // 3. 㲥 Socket յϢ
        InWebSocketManager1.Broadcast(Socket);

        // 4. յϢ ToUser
        InWebSocketManager1.SendTo(Socket, 'ToUser');

        // 5. 㲥һıϢ
        InWebSocketManager1.Broadcast('Թ㲥');

        // 6. һı ToUser
        InWebSocketManager1.SendTo('ToUser', '͸ToUser');

        // 7. ɾͻ AAA
        if (Socket.Role >= crAdmin) then  // Ȩ
          InWebSocketManager1.Delete(Socket, 'ûA'); }

    //    Memo1.Lines.Add('յ WebSocket Ϣ' + S);  // 󲢷Ҫʾ
      end;
    end;
  end;
end;

procedure TFormInIOCPWsJSON.InWebSocketManager1Upgrade(Sender: TObject;
  const Origin: string; var Accept: Boolean);
begin
  // Origin:  Socket Դ磺www.aaa.com
  // ڴжǷΪ WebSocketĬ Accept=True
end;

procedure TFormInIOCPWsJSON.InWSConnection1ReceiveData(Sender: TObject; const Msg: string);
begin
  // Sender:  TInWSConnection
  //    MsgյϢı

  // յĲ InIOCP-JSON Ϣδװݣ
  // ԷһϢڷ˹㲥

  Memo1.Lines.Add(Msg);
end;

procedure TFormInIOCPWsJSON.InWSConnection1ReceiveMsg(Sender: TObject; Msg: TJSONResult);
begin
  //  Sender:  TInWSConnection
  //     Msg: JSON ϢϵͳԶͷ

  // յͻ InIOCP-JSON Ϣգ
  // Է TJSONMessage Ϣڷ˹㲥

  Memo1.Lines.Add('յϢգ' + Msg.S['push']);
end;

procedure TFormInIOCPWsJSON.InWSConnection1ReturnResult(Sender: TObject; Result: TJSONResult);
begin
  // Sender:  TInWSConnection
  // Result: JSON ϢϵͳԶͷ
  
  // Result.MsgType: Ϣ
  //   1. mtJSONResult  JSON Ϣ
  //   2. mtAttachmentResult ǸϵͳԶͷţҪ Result.Attachment.Free

  // Result.AttachType: ֣ͣ
  //   1. 2. ݼ

  // ԷյϢ Socket.Result Socket.SendResult ͻ

  Memo1.Lines.Add('====== ͻ ======');

  if Result.MsgType = mtJSON then
  begin
    if Result.HasAttachment then  // иգԲգ
      Result.Attachment := TFileStream.Create('temp\ͻյ' + Result.S['attach'], fmCreate);
    Memo1.Lines.Add('˷ظԼ JSON Ϣ: ' + Result.S['return']);
  end else  // Ǹ
  if Assigned(Result.Attachment) then  // յļ
  begin
    if Result.HasAttachment then
      Memo1.Lines.Add('ļϣϵͳԶرո')
    else
      Memo1.Lines.Add('ݼϣJSONʽ')
  end else
    Memo1.Lines.Add('ûнļ');
end;

end.
